//+------------------------------------------------------------------+
//|                                                           MA.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 Red
#property indicator_color2 Chocolate
#property indicator_color3 Orange
#property indicator_color4 ForestGreen
#property indicator_color5 RoyalBlue
#property indicator_color6 Blue
#property indicator_color7 Magenta
#property indicator_color8 Red
extern string     xxxxxxxxxxxxxxxxxxxxxxxxxxxxx =  "---------------------------------------------------------";
extern string     ="";
extern int        T=0;
extern string     xxxxxxxxxxxxxxxxxxxxxxxxxxxxxx =  "---------------------------------------------------------";
extern string     PEriod=" SMA";
extern int        Period_1= 36;
extern int        Period_2 =49;
extern int        Period_3= 64;
extern int        Period_4 =144;
extern int        Period_5= 169;
extern int        Period_6 =196;
extern int        Period_7= 400;
extern int        Period_8 =625;
extern string     xxxxxxxxxxxxxxxxxxxxxxxxxxxxx =  "---------------------------------------------------------";
extern string     __ = "0  1  2  3 -";
extern int        __=0;
extern bool       __=false;

extern color Color1 = Red;
extern color Color2 = Chocolate;
extern color Color3 = Orange;
extern color Color4 = ForestGreen;
extern color Color5 = CornflowerBlue;
extern color Color6 = Blue;
extern color Color7 = Magenta;
extern color Color8 = DarkViolet;
//----

double ma1_buffer [];
double ma2_buffer [];
double ma3_buffer [];
double ma4_buffer [];
double ma5_buffer [];  
double ma6_buffer [];  
double ma7_buffer [];  
double ma8_buffer [];  

string   short;
int tmp;
int pos;
int a_begin;
string sma[8]; 
color colore[8];
  

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  sma[0]="SMA("+Period_1+")";
  sma[1]="SMA("+Period_2+")";
  sma[2]="SMA("+Period_3+")";
  sma[3]="SMA("+Period_4+")";
  sma[4]="SMA("+Period_5+")";
  sma[5]="SMA("+Period_6+")";
  sma[6]="SMA("+Period_7+")";
  sma[7]="SMA("+Period_8+")";
  
   colore[0] = Color1;
   colore[1] = Color2;
   colore[2] = Color3;
   colore[3] = Color4;
   colore[4] = Color5;
   colore[5] = Color6;
   colore[6] = Color7;   
   colore[7] = Color8;   

  for ( int i_44 = 7; i_44 > -1; i_44--) 
  {SetIndexLabel(i_44, sma[i_44]);}
   
  for ( i_44 = 7; i_44 > -1; i_44--) 
  {SetIndexStyle(i_44,DRAW_LINE,EMPTY,i_44,colore[i_44]);}

   SetIndexBuffer(0, ma1_buffer);
   SetIndexBuffer(1, ma2_buffer);
   SetIndexBuffer(2, ma3_buffer);
   SetIndexBuffer(3, ma4_buffer);
   SetIndexBuffer(4, ma5_buffer);
   SetIndexBuffer(5, ma6_buffer);
   SetIndexBuffer(6, ma7_buffer);
   SetIndexBuffer(7, ma8_buffer);
   
  short="ma";
   IndicatorShortName(short);


   return(0);
  }
//+------------------------------------------------------------------+
int deinit()  { ObjectsDeleteAll(0,OBJ_LABEL);  return(0);  }
//+------------------------------------------------------------------+
int start()  {
//----
int kolvo=0;
pos = iBarShift(0,T,iTime(0,1440,2),FALSE );
double buf_X[201][2000];
double kolvo_buf[2000];
   
for(;pos>=0;pos--)  
for (int r=1;r<=200;r+=1) 
     buf_X[r][pos] = iMA(NULL, T , r, 0, __, 4, pos);
     
     
pos = iBarShift(0,T,iTime(0,1440,2),FALSE );  
 
for(;pos>=0;pos--)
{






for (r=2;r<=200;r+=1)
 {
       if(buf_X[r][pos+2]!=0) 
       if((buf_X[1][pos+2]>buf_X[r][pos+2]&&buf_X[1][pos+1]<buf_X[r][pos+1])
       || (buf_X[1][pos+2]<buf_X[r][pos+2]&&buf_X[1][pos+1]>buf_X[r][pos+1])
       ){
       kolvo++;
   
       kolvo_buf[r]=kolvo;
       kolvo_buf[10]=kolvo;
}
  }
  
  
  
  
  
  
  
kolvo=0; 

}
Alert(kolvo_buf[60],"  " , kolvo_buf[100],"   ",pos);
pos = iBarShift(0,T,iTime(0,1440,2),FALSE );

  for(;pos>=0;pos--)
{
       
  ma1_buffer[pos] = buf_X[10][pos];
  ma2_buffer[pos] = buf_X[20][pos];
  ma3_buffer[pos] = buf_X[30][pos];
  ma4_buffer[pos] = buf_X[40][pos];
  ma5_buffer[pos] = buf_X[50][pos];
  ma6_buffer[pos] = buf_X[60][pos];
  ma7_buffer[pos] = buf_X[70][pos];
  ma8_buffer[pos] = buf_X[80][pos]; }
   



double ma_buffer[8];
    ma_buffer[0]= (Bid-ma1_buffer [0])/Point;    
    ma_buffer[1]= (Bid-ma2_buffer [0])/Point;    
    ma_buffer[2]= (Bid-ma3_buffer [0])/Point;
    ma_buffer[3]= (Bid-ma4_buffer [0])/Point;   
    ma_buffer[4]= (Bid-ma5_buffer [0])/Point;    
    ma_buffer[5]= (Bid-ma6_buffer [0])/Point;    
    ma_buffer[6]= (Bid-ma7_buffer [0])/Point;
    ma_buffer[7]= (Bid-ma8_buffer [0])/Point;   
string text[8];   
  text[0]=DoubleToStr(ma_buffer[0],0) ;  
  text[1]=DoubleToStr(ma_buffer[1],0) ;  
  text[2]=DoubleToStr(ma_buffer[2],0) ;
  text[3]=DoubleToStr(ma_buffer[3],0) ;  
  text[4]=DoubleToStr(ma_buffer[4],0) ;  
  text[5]=DoubleToStr(ma_buffer[5],0) ;  
  text[6]=DoubleToStr(ma_buffer[6],0) ;  
  text[7]=DoubleToStr(ma_buffer[7],0) ;  
int koef=16;
int labe[8]; 
   labe[0]=0;   
   labe[1]=koef; 
   labe[2]=labe[1]+koef;   
   labe[3]=labe[2]+koef;  
   labe[4]=labe[3]+koef;   
   labe[5]=labe[4]+koef;   
   labe[6]=labe[5]+koef;
   labe[7]=labe[6]+koef;   
   labe[8]=labe[7]+koef;

int =12;
/*for (int i_4 = 7; i_4 > -1; i_4--) {
   ObjectDelete(colore[i_4]+"2");
   ObjectCreate(colore[i_4]+"2", OBJ_LABEL, 0, 0, 0);
   ObjectSet(colore[i_4]+"2", OBJPROP_CORNER, 1);
   ObjectSet(colore[i_4]+"2", OBJPROP_YDISTANCE, labe[i_4 ] + 5);
   ObjectSet(colore[i_4]+"2", OBJPROP_XDISTANCE, 60);
   ObjectSetText(colore[i_4]+"2",sma[i_4],, "Times New Roman", colore[i_4]);
   }
for ( i_4 = 7; i_4 > -1; i_4--) {
   ObjectDelete(colore[i_4]+"3");
   ObjectCreate(colore[i_4]+"3", OBJ_LABEL, 0, 0, 0);
   ObjectSet(colore[i_4]+"3", OBJPROP_CORNER, 1);
   ObjectSet(colore[i_4]+"3", OBJPROP_YDISTANCE, labe[i_4 ] + 5);
   ObjectSet(colore[i_4]+"3", OBJPROP_XDISTANCE, 5);
   ObjectSetText(colore[i_4]+"3",text[i_4],, "Times New Roman", colore[i_4]);
   }*/
   return(0);
  }
//+------------------------------------------------------------------+